"use strict";
exports.__esModule = true;
exports.withLoader = void 0;
var tslib_1 = require("tslib");
var react_1 = (0, tslib_1.__importDefault)(require("react"));
var RTKLoader_1 = require("./RTKLoader");
var withLoader = function (Component, args) {
    var CachedComponent;
    var LoaderComponent = function (props) {
        var _a, _b, _c, _d, _e, _f;
        var useLoaderArgs = [];
        if (args.queriesArg) {
            useLoaderArgs.push(args.queriesArg(props));
        }
        var query = args.useLoader.apply(args, useLoaderArgs);
        if (!CachedComponent) {
            CachedComponent = react_1["default"].forwardRef(Component);
        }
        return (react_1["default"].createElement(RTKLoader_1.RTKLoader, { query: query, loader: (_a = args.onLoading) === null || _a === void 0 ? void 0 : _a.call(args, props), onError: args.onError
                ? function (error) {
                    var _a, _b;
                    return (_b = (_a = args.onError) === null || _a === void 0 ? void 0 : _a.call(args, props, error, query)) !== null && _b !== void 0 ? _b : react_1["default"].createElement(react_1["default"].Fragment, null);
                }
                : undefined, onSuccess: function (data) { return (react_1["default"].createElement(CachedComponent, (0, tslib_1.__assign)({}, props, { ref: data }))); }, whileFetching: args.whileFetching
                ? {
                    prepend: (_c = (_b = args.whileFetching) === null || _b === void 0 ? void 0 : _b.prepend) === null || _c === void 0 ? void 0 : _c.call(_b, props, query === null || query === void 0 ? void 0 : query.data),
                    append: (_e = (_d = args.whileFetching) === null || _d === void 0 ? void 0 : _d.append) === null || _e === void 0 ? void 0 : _e.call(_d, props, query === null || query === void 0 ? void 0 : query.data)
                }
                : undefined, onFetching: (_f = args === null || args === void 0 ? void 0 : args.onFetching) === null || _f === void 0 ? void 0 : _f.call(args, props, query.data
                ? function () { return (react_1["default"].createElement(CachedComponent, (0, tslib_1.__assign)({}, props, { ref: query.data }))); }
                : function () { return react_1["default"].createElement(react_1["default"].Fragment, null); }) }));
    };
    return LoaderComponent;
};
exports.withLoader = withLoader;
//# sourceMappingURL=withLoader.js.map